// subpages/orderconfirm/orderconfirm.js
var app = getApp();
Page({

    /**
     * 页面的初始数据
     */
    data: {
        token: '',
        imgUrl: app.shopImgUrl,
        addressBean: {},
        hidePageLoading: false,
        goodsList: [],
        imgUrl: app.shopImgUrl,
        remark: '',
        totalPrice: 0,
        carList: []
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad(options) {
        var _self = this;
        _self.getToken().then(result => {
            _self.getDefaultAddress();
            _self.getGoodsCar();
        })
    },
    getToken() {
        var self = this;
        return new Promise(resolve => {
            wx.getStorage({
                key: 'token',
                success(res) {
                    self.setData({
                        token: res.data
                    })
                    return resolve();
                }
            })
        })
    },
    //获取默认地址
    getDefaultAddress() {
        var _self = this;
        app.restAjax.get(app.restAjax.path('{shopUrl}/app/shopaddress/getdefault', [app.shopUrl]), null, {
            headers: {
                token: _self.data.token
            }
        }, function (code, data) {
            wx.hideLoading()
            if (code == 200) {
                _self.setData({
                    addressBean: data,
                    hidePageLoading: true
                })
            }
        }, function (code, data) {
            app.dialog.msg(data.msg)
            _self.setData({
                hidePageLoading: true
            })
        });
    },
    getGoodsCar() {
        var _self = this;
        var tempPrice = 0;
        try {
            var carList = wx.getStorageSync('carlist');
            console.log(carList)
            if (carList) {
                for (let i = 0; i < carList.length; i++) {
                    const item = carList[i];
                    if (item.isCheck) {
                        _self.data.goodsList.push(item);
                        tempPrice = item.carAmount * item.goodsPrice + tempPrice;
                    }
                }
                _self.setData({
                    carList: carList,
                    goodsList: _self.data.goodsList,
                    totalPrice: tempPrice
                })
            }
        } catch (error) {

        }
    },
    inputRemark(e) {
        var value = e.detail.value
        this.setData({
            remark: value
        })
    },
    doSelAddress() {
        //选择地址
        wx.navigateTo({
            url: '/subpages/addresschoose/addresschoose',
        })
    },
    checkParams() {

    },
    doConfirmOrder() {
        var _self = this;
        var tempList = [];
        for (let i = 0; i < _self.data.goodsList.length; i++) {
            const item = _self.data.goodsList[i];
            var tempItem = {
                count: item.carAmount,
                goodsId: item.goodsId,
                goodsItemId: item.goodsStandarId,
            };
            tempList.push(tempItem);
        }
        var saveBean = {
            goodsItemList: tempList,
            shopAddressId: _self.data.addressBean.shopAddressId,
            words: _self.data.remark
        };
        app.dialog.loading("下单中...")
        app.restAjax.post(app.restAjax.path('{shopUrl}/app/order/savebycart', [app.shopUrl]), saveBean, {
            headers: {
                token: _self.data.token
            }
        }, function (code, data) {
            wx.hideLoading()
            if (code == 200) {
                wx.showToast({
                    title: '下单成功',
                    success() {
                        //删除购物车中的数据
                        for (let i = _self.data.carList.length - 1; i >= 0; i--) {
                            const element = _self.data.carList[i];
                            if (element.isCheck) {
                                _self.data.carList.splice(i, 1);
                            }
                        }
                        _self.setData({
                            carList: _self.data.carList
                        })
                        wx.setStorageSync('carlist', _self.data.carList)
                        setTimeout(function () {
                            wx.navigateBack()
                        }, 1000);
                    }
                })
            }
        }, function (code, data) {
            app.dialog.msg(data.msg)
        });
    }
})